function [results,vdxi,Q]= DSS(M,N,data,inputs,spectrumfunc,S,samplerParameters)
get_spectrum=spectrumfunc;

output=cellfun(@(Cx)get_spectrum(Cx,1),data,'UniformOutput', false);

%get the required matrices
for ii=1:length(output);
    current=output{ii};
    spectrum=current{1};
    derivative=current{2};
    if(~isempty(inputs))
        xi=[spectrum(:,setdiff([1:N],inputs)),spectrum(:,inputs)];
        xid=[derivative(:,setdiff([1:N],inputs))];
    else
        xi=spectrum;
        xid=derivative;
    end;
    [m,l]=size(xid(:,:,1));
    xixi=[real(xi);imag(xi)]'*[real(xi);imag(xi)];
    temp=[real(xi);imag(xi)]'*[real(xid);imag(xid)];
    realxi=real(xi);
    imagxi=imag(xi);
    Qt=[realxi;imagxi];
    Q{ii}=kron(eye(l),Qt);

    vdxit=[real(xid);imag(xid)];
    vdxi{ii}=vec(vdxit);
    
    xidxi(:,ii)=vec(temp);
    
    kronxi(:,:,ii)=kron(eye(l),xixi);

end;   

xidxi=sum(xidxi,2);
kronxi=sum(kronxi,3);

% ok, now with that nasty business out of the way we can start with the sampling!

%first the parameters

%Sampler parameters


%number of samples
samples=samplerParameters.Samples;

%spike to zero
v0=samplerParameters.V0;

%prior strength, relic from the past, will get rid of it asap
pweight=zeros(N); % 90 per cent

%parameters of the beta distribution controlling the sparsity parameterd
b1=samplerParameters.B1;
b2=samplerParameters.B2; 
%tau parameters
a1=samplerParameters.A1*ones(l,N);
a2=samplerParameters.A2*ones(l,N); 
%variance parameter
d1=samplerParameters.D1;
d2=samplerParameters.D2;
d1=d1*ones(N-3,1);
d2=d2*ones(N-3,1);

%sequence variance parameter
e1=samplerParameters.E1;
e2=samplerParameters.E2;

%% Set the sampler distributions
Hprior=zeros(N);%again a relic
%distribution of the adjacnecy matrix on top
hdist=@(Apropx,taupropx,wpropx,betapropx,hpropx,seqprecx)ph_strongPrior(Hprior,pweight,S,Apropx,taupropx,v0,wpropx,betapropx,hpropx,seqprecx); %%%i have to change this so its the strong prior over H

%distribution of the lti coefficients 
Adist=@(hyperx,precisionx)pA(m*l,kronxi,hyperx,xidxi,precisionx);

%distribution of the sparsity parameter (prior and given H)
wdist=@(hpropx)pw_H(b1,b2,hpropx,v0);

%distribution of tau (prior and given A, h)
taudist=@(Apropx,hpropx)ptau(Apropx,hpropx,a1,a2);

%Distribution of the variance(precision) given the profiles
precisiondist=@(bx)psigregMultiple(d1,d2,vdxi,Q,bx);

%Distribution of the sequence variance 
seqprecisiondist=@(sx,hx,bx)psigreg(e1,e2,sx,hx,bx);

%Distribtuiion of the beta coefficients, in this case we are using the
%nonnegative least squares solution
betadist=@(hpropx)cLSBeta(S,hpropx); %the least squares estimates of course

%% Sample!!!
results=GibbsSampler_freq(N,l,v0,d1,d2,e1,e2,samples,wdist,taudist,Adist,betadist,hdist,precisiondist,seqprecisiondist);


end