%%%%%%%%%%%%%%%%%%
% Experiments with the dream data set
%% first we read the data with the superscript!
odeFile='../Data/insilico_size10_2_nonoise_timeseries.csv';
sdeFile='../Data/insilico_size10_2_noexpnoise_timeseries.tsv';
nsdeFile='../Data/insilico_size10_2_timeseriessde.csv';

rng(130784); %%random seed
%wildtype


[odeData,headers]=myReadTable(odeFile);
%get rid of time column
for ii=1:length(odeData)
    temp=odeData{ii};
    odeData{ii}=temp(:,2:end);
end;



[sdeData,headers]=myReadTable(sdeFile);
%get rid of time column
for ii=1:length(sdeData)
    temp=sdeData{ii};
    sdeData{ii}=temp(:,2:end);
end;



[nsdeData,headers]=myReadTable(nsdeFile);
%get rid of time column
for ii=1:length(nsdeData)
    temp=nsdeData{ii};
    nsdeData{ii}=temp(:,2:end);
end;





genes=headers(2:end); %get the gene names





%% Now the true H matrix from the goldstandard, right now i will use the true one
H=zeros(10);
H(2,1)=1;
H(2,5)=1;
H(3,4)=1;
H(3,10)=1;
H(3,5)=1;
H(4,2)=1;
H(4,3)=1;
H(5,4)=1;
H(5,2)=1;
H(5,9)=1;
H(5,3)=1;
H(6,2)=1;
H(6,7)=1;
H(7,6)=1;
H(7,2)=1;
H(8,2)=1;

Hs=zeros(10);
Hs(2,1)=1;
Hs(2,5)=1;
Hs(3,4)=1;
Hs(3,10)=1;
Hs(3,5)=1;
Hs(4,2)=-1;
Hs(4,3)=1;
Hs(5,4)=-1;
Hs(5,2)=-1;
Hs(5,9)=-1;
Hs(5,3)=1;
Hs(6,2)=1;
Hs(6,7)=-1;
Hs(7,6)=1;
Hs(7,2)=1;
Hs(8,2)=-1;




Betas= unifrand(0.1*ones(10,1),0.6*ones(10,1));

%% Similarity matrix


S=H*diag(Betas)*H'.*(ones(10)-eye(10));



%% substracting the mean
% additionally get rid of the post transcriptional elements, leaving the option of
%adding them later if it's interesting.


    for jj=1:length(odeData)
       odeData{jj}= bsxfun(@minus,odeData{jj},mean(odeData{jj}));
    end
    
    
    for jj=1:length(sdeData)
       sdeData{jj}= bsxfun(@minus,sdeData{jj},mean(sdeData{jj}));
    end
    
    
    for jj=1:length(nsdeData)
       nsdeData{jj}= bsxfun(@minus,nsdeData{jj},mean(nsdeData{jj}));
    end    
%%
clear genie3odeData;
clear genie3sdeData;
clear genie3nsdeData;

%normalize for genie3
  for ii=1:length(odeData)
      genie3odeData{ii}=zscore(odeData{ii});
      genie3sdeData{ii}=zscore(sdeData{ii});
      genie3nsdeData{ii}=zscore(nsdeData{ii});
  

  end;
  VIMode=genie3_time(genie3odeData);
  VIMsde=genie3_time(genie3sdeData);
  VIMnsde=genie3_time(genie3nsdeData);
 
  [M,N]=size(odeData{1});
% 
%  writeInferelator(genie3odeData,M,genes,H);
%  writeInferelator(genie3sdeData,M,genes,H);
%  writeInferelator(genie3nsdeData,M,genes,H);
%%

 parameters=DSSparameters;


[resultsODE,vdxiode,Qode]=DSS(M,N,odeData,[],@cellFFTSpectrum,[],parameters);
[resultsSDE,vdxisde,Qsde]=DSS(M,N,sdeData,[],@cellFFTSpectrum,[],parameters);
[resultsNSDE,vdxinsde,Qnsde]=DSS(M,N,nsdeData,[],@cellFFTSpectrum,[],parameters);


resultsODEs=DSS(M,N,odeData,[],@cellFFTSpectrum,S,parameters);
resultsSDEs=DSS(M,N,sdeData,[],@cellFFTSpectrum,S,parameters);
resultsNSDEs=DSS(M,N,nsdeData,[],@cellFFTSpectrum,S,parameters);
%%
estODE=mean(resultsODE.H(:,:,end-1000:end),3);
estSDE=mean(resultsSDE.H(:,:,end-1000:end),3);
estNSDE=mean(resultsNSDE.H(:,:,end-1000:end),3);
estODEs=mean(resultsODEs.H(:,:,end-1000:end),3);
estSDEs=mean(resultsSDEs.H(:,:,end-1000:end),3);
estNSDEs=mean(resultsNSDEs.H(:,:,end-1000:end),3);
  
  
clear estODEv;
clear estSDEv;
clear estNSDEv;
clear estODEsv;
clear estSDEsv;
clear estNSDEsv;
clear VIModev;
clear VIMsdev;
clear VIMnsdev;
clear lassoODEv;
clear lassoSDEv;
clear lassoNSDEv;


clear acum1;
clear acum2;
acum1=vdxiode{1};
acum2=Qode{1};
for ii=2:size(odeData)
     acum1=acum1+vdxiode{ii};
     acum2=acum2+Qode{ii};
end
lambda=linspace(0,100,100);
fit = glmnet(acum2, acum1)
co=glmnetCoef(fit);


cODE=reshape(co(2:end,end),10,10);
cODE=cODE';

clear acum1;
clear acum2;
acum1=vdxisde{1};
acum2=Qsde{1};
for ii=2:size(sdeData)
     acum1=acum1+vdxisde{ii};
     acum2=acum2+Qsde{ii};
end
lambda=linspace(0,100,100);
fit = glmnet(acum2, acum1)
co=glmnetCoef(fit);


cSDE=reshape(co(2:end,end),10,10);
cSDE=cSDE';
clear acum1;
clear acum2;
acum1=vdxinsde{1};
acum2=Qnsde{1};
for ii=2:size(nsdeData)
     acum1=acum1+vdxinsde{ii};
     acum2=acum2+Qnsde{ii};
end
lambda=linspace(0,100,100);
fit = glmnet(acum2, acum1)
co=glmnetCoef(fit);


cNSDE=reshape(co(2:end,end),10,10);
cNSDE=cNSDE';

clear Hv;
counter=1;
[M,N]=size(estODE);
for ii=1:M
    for jj=1:N
        if(ii~=jj)
            estODEv(counter)=estODE(ii,jj);
            estSDEv(counter)=estSDE(ii,jj);
            estNSDEv(counter)=estNSDE(ii,jj);
            estODEsv(counter)=estODEs(ii,jj);
            estSDEsv(counter)=estSDEs(ii,jj);
            estNSDEsv(counter)=estNSDEs(ii,jj);
            VIModev(counter)=VIMode(ii,jj);
            VIMsdev(counter)=VIMsde(ii,jj);
            VIMnsdev(counter)=VIMnsde(ii,jj);
            lassoODEv(counter)=cODE(ii,jj);
            lassoSDEv(counter)=cSDE(ii,jj);
            lassoNSDEv(counter)=cNSDE(ii,jj);
            
            Hv(counter)=H(ii,jj);
            
            counter=counter+1;
        end;
    end;
end;





[prec, tpr, fpr, thresh,preci,tpri]=prec_rec(estODEv,Hv,'ODE','plotPR',1,'plotBaseline',1);

             auroc=trapz([0; fpr], [0; tpr]);
            auprODE=trapz([0; tpri],[1 ; preci]);
%             
[prec3, tpr3, fpr3, thresh3,preci3,tpri3]=prec_rec(estSDEv,Hv,'SDE','plotPR',1,'plotBaseline',1,'holdFigure',1)
auprSDE=trapz([0; tpr3],[1 ; prec3]);
auroc3=trapz([0; fpr3], [0; tpr3]);


[prec4, tpr4, fpr4, thresh4,preci4,tpri4]=prec_rec(estNSDEv,Hv,'NSDE','plotPR',1,'plotBaseline',1,'holdFigure',1)
auprNSDE=trapz([0; tpr4],[1 ; prec4]);
auroc4=trapz([0; fpr4], [0; tpr4]);


[prec5, tpr5, fpr5, thresh5,preci5,tpri5]=prec_rec(estODEsv,Hv,'ODE with similarity','plotPR',1,'plotBaseline',1,'holdFigure',1)
auprODEs=trapz([0; tpr5],[1 ; prec5]);
auroc5=trapz([0; fpr3], [0; tpr3]);



[prec6, tpr6, fpr6, thresh6,preci6,tpri6]=prec_rec(estSDEsv,Hv,'SDE with similarity','plotPR',1,'plotBaseline',1,'holdFigure',1)
auprSDEs=trapz([0; tpr6],[1 ; prec6]);
auroc6=trapz([0; fpr6], [0; tpr6]);


[prec7, tpr7, fpr7, thresh7,preci7,tpri7]=prec_rec(estNSDEsv,Hv,'NSDE with similarity','plotPR',1,'plotBaseline',1,'holdFigure',1)
auprNSDEs=trapz([0; tpr7],[1 ; prec7]);
auroc7=trapz([0; fpr7], [0; tpr7]);

 
 % legend5=['Inferelator',char(10),'AUPR=',num2str(auroc5)];

 [prec4, tpr4, fpr4, thresh4,preci4,tpri4]=prec_rec(VIModev,Hv,'Genie3','plotPR',1,'plotBaseline',1,'holdFigure',1)
 auprGenie3ODE=trapz([0; tpr4],[1 ; prec4]);
 [prec4, tpr4, fpr4, thresh4,preci4,tpri4]=prec_rec(VIMsdev,Hv,'Genie3','plotPR',1,'plotBaseline',1,'holdFigure',1)
 auprGenie3SDE=trapz([0; tpr4],[1 ; prec4]);
 [prec4, tpr4, fpr4, thresh4,preci4,tpri4]=prec_rec(VIMnsdev,Hv,'Genie3','plotPR',1,'plotBaseline',1,'holdFigure',1)
 auprGenie3NSDE=trapz([0; tpr4],[1 ; prec4]);
% auroc4=trapz([0; fpr4], [0; tpr4]);

 prinferelatorsde=dlmread('../Data/Inferelator/dreamsde/curve.csv','\t');
 prec5=prinferelatorsde(:,1);
 tpr5=prinferelatorsde(:,2);
 
 auprInferSDE=trapz([0; tpr5],[1 ; prec5]);
 
 prinferelatornsde=dlmread('../Data/Inferelator/dreamnsde/curve.csv','\t');
 prec6=prinferelatornsde(:,1);
 tpr6=prinferelatornsde(:,2);
 auprInferNSDE=trapz([0; tpr6],[1 ; prec6]);

 
 [prec4, tpr4, fpr4, thresh4,preci4,tpri4]=prec_rec(abs(lassoODEv),Hv,'Genie3','plotPR',1,'plotBaseline',1,'holdFigure',1)
 auprlassoODE=trapz([0; tpr4],[1 ; prec4]);
 
 
 

 [prec4, tpr4, fpr4, thresh4,preci4,tpri4]=prec_rec(abs(lassoSDEv),Hv,'Genie3','plotPR',1,'plotBaseline',1,'holdFigure',1)
 auprlassoSDE=trapz([0; tpr4],[1 ; prec4]);
 
 [prec4, tpr4, fpr4, thresh4,preci4,tpri4]=prec_rec(abs(lassoNSDEv),Hv,'Genie3','plotPR',1,'plotBaseline',1,'holdFigure',1)
 auprlassoNSDE=trapz([0; tpr4],[1 ; prec4]);
 
 
 
 dss=[auprODE auprSDE auprNSDE];
 dssS=[auprODEs auprSDEs auprNSDEs];
 genie3=[auprGenie3ODE auprGenie3SDE auprGenie3NSDE];
 inferelator=[0 auprInferSDE auprInferNSDE];
 lassoQ=[auprlassoODE auprlassoSDE auprlassoNSDE];
 
 bar([1 2 3],[dss' dssS' genie3' inferelator' lassoQ'])
 legend('DSS','DSS with S','genie3','Inferelator','LASSO');
 ax=gca;
set(ax, 'XTick',[1 2 3],'XTickLabel',{'ODE','SDE','SDE w. Noise' },'FontSize',12);
ylabel('AUPR','FontSize',14);
xlabel('Simulation data set','FontSize',14);
title('AUPR for the DREAM4 oscillating network data set');


%%

close all;
subplot(2,2,1);
plot(nsdeData{1});
xlabel('Time','FontSize',14);
ylabel('Expression level','FontSize',14);
title('Expression profiles for the DREAM 4 challenge SDE simulation with noise','FontSize',16);

subplot(2,2,2)
dss=[auprODE auprSDE auprNSDE];
 dssS=[auprODEs auprSDEs auprNSDEs];
 genie3=[auprGenie3ODE auprGenie3SDE auprGenie3NSDE];
 inferelator=[0 auprInferSDE auprInferNSDE];
 lassoQ=[auprlassoODE auprlassoSDE auprlassoNSDE];
 
 bar([1 2 3],[dss' dssS' genie3' inferelator' lassoQ'])
 legend('DSS','DSS with S','genie3','Inferelator','LASSO');
 ax=gca;
set(ax, 'XTick',[1 2 3],'XTickLabel',{'ODE','SDE','SDE w. Noise' },'FontSize',12);
ylabel('AUPR','FontSize',14);
xlabel('Simulation data set','FontSize',14);
title('AUPR for the DREAM4 oscillating network data set','FontSize',16);
legend('location','northwest')
%colormap(fig,'parula');

subplot(2,2,3)
  A=H;
r =  1;
theta = linspace(0,2*pi,N+1)'; theta(end) = [];
xy = r .* [cos(theta) sin(theta)];
p = symrcm(A);
%A = A(p,p);
txt = genes
%txt = txt(p,:);
%# labels of nodes


%# show nodes and edges
line(xy(:,1), xy(:,2), 'LineStyle','none', ...
    'Marker','.', 'MarkerSize',15, 'Color','g')
hold on
[gr]=gplotd(A, xy, 'b-')
axis([-1 1 -1 1]); axis equal off
hold off

%# show node labels
h = text(xy(:,1).*1.05, xy(:,2).*1.05, txt, 'FontSize',16,'FontWeight','bold' );
%set(h, {'Rotation'},num2cell(theta*180/pi))

title('True network','Fontsize',16);


subplot(2,2,4)
 A=(estNSDEs-eye(N)>0.5);
% A=H;
r =  1;
theta = linspace(0,2*pi,N+1)'; theta(end) = [];
xy = r .* [cos(theta) sin(theta)];
p = symrcm(A);
%A = A(p,p);
txt = genes
%txt = txt(p,:);
%# labels of nodes


%# show nodes and edges
line(xy(:,1), xy(:,2), 'LineStyle','none', ...
    'Marker','.', 'MarkerSize',15, 'Color','g')
hold on
[gr]=gplotd(A, xy, 'b-')
axis([-1 1 -1 1]); axis equal off
hold off

%# show node labels
h = text(xy(:,1).*1.05, xy(:,2).*1.05, txt, 'FontSize',16,'FontWeight','bold' );
%set(h, {'Rotation'},num2cell(theta*180/pi))
title('Inferred network','FontSize',16)
