%%%%%%%%%%%%%%%%%%
% Experiments with the dream data set
%% first we read the data with the superscript!
msgbox('Import data file');
 [dtafile,datapath]=uigetfile();
 file=[datapath,dtafile];
msgbox('Results directory');

savepath=uigetdir();

%% Now the true H matrix from the goldstandard, right now i will use the true one
H=zeros(10);
H(2,1)=1;
H(2,5)=1;
H(3,4)=1;
H(3,10)=1;
H(3,5)=1;
H(4,2)=1;
H(4,3)=1;
H(5,4)=1;
H(5,2)=1;
H(5,9)=1;
H(5,3)=1;
H(6,2)=1;
H(6,7)=1;
H(7,6)=1;
H(7,2)=1;
H(8,2)=1;

Hs=zeros(10);
Hs(2,1)=1;
Hs(2,5)=1;
Hs(3,4)=1;
Hs(3,10)=1;
Hs(3,5)=1;
Hs(4,2)=-1;
Hs(4,3)=1;
Hs(5,4)=-1;
Hs(5,2)=-1;
Hs(5,9)=-1;
Hs(5,3)=1;
Hs(6,2)=1;
Hs(6,7)=-1;
Hs(7,6)=1;
Hs(7,2)=1;
Hs(8,2)=-1;




[series,headers]=readtable(file);
Betas= unifrand(0.1*ones(10,1),0.6*ones(10,1));

%% Similarity matrix


S=H*diag(Betas)*H'.*(ones(10)-eye(10));

%% the time is in the first column, each time series is in a cell of the
% data cell array, so lets just grab one at the time.

data1=cell2mat(series(1)); %select a data series
time=data1(:,1); %the times are in the first column.
data1=data1(:,2:end);
data2=cell2mat(series(2));
data2=data2(:,2:end);
data3=cell2mat(series(3));
data3=data3(:,2:end);
data4=cell2mat(series(4));
data4=data4(:,2:end);
data5=cell2mat(series(5));
data5=data5(:,2:end);
[M,N]=size(data1);

genes=headers(2:end); %get the gene names



%% substract the mean from the signals.

data= data1;

    for ii=1:N
        data1(:,ii)=detrend(data1(:,ii),0);
        data2(:,ii)=detrend(data2(:,ii),0);
        data3(:,ii)=detrend(data3(:,ii),0);
        data4(:,ii)=detrend(data4(:,ii),0);
        data5(:,ii)=detrend(data5(:,ii),0);
    end;
    

%%
testdata={data1,data2,data3,data4,data5};
  VIM2=genie3_time(testdata);
get_link_list(VIM2,1:size(VIM2,1),{},0,[savepath,'ranking_edges.txt']);

 [M,N]=size(data1);

writeInferelator(testdata,M,genes,H);

%%
 results2=sampleMultiple(M,N,testdata,[],@cellFFTSpectrum2,S);
[results,vdxi,Q]=sampleMultiple(M,N,testdata,[],@cellFFTSpectrum2,[]);


thisH=mean(results.H(:,:,500:end),3);
thisA=mean(results.A(:,:,500:end),3);


%tic;sampleMultiple(M,N,testdata,[],@cellFFTSpectrum2,S); toc


constrain=1;
zeromean=1;
testdata2=testdata;


%VIM2=genie3_time(testdata2);
estH=mean(results.H(:,:,end-1000:end),3);
estH2=mean(results2.H(:,:,end-1000:end),3);
[M,N]=size(estH);
estH(1:M,1:M)=estH(1:M,1:M)-eye(M);
figure;
imagesc(estH2);
set(gca,'xTickLabel',genes);
  set(gca,'yTickLabel',genes);
  colorbar
  ylabel('targets');
  xlabel('transcription factors');
  title('spike and slab')
figure;
  imagesc(-H);
set(gca,'xTickLabel',genes);
  set(gca,'yTickLabel',genes);
  colormap('gray')
  ylabel('targets');
  xlabel('transcription factors');
  title('spike and slab')
  
  
  
  clear acum1;
clear acum2;
acum1=vdxi{1};
acum2=Q{1};
for ii=2:size(testdata)
     acum1=acum1+vdxi{ii};
     acum2=acum2+Q{ii};
end
lambda=linspace(0,100,100);
fit = glmnet(acum2, acum1)
co=glmnetCoef(fit);


c=reshape(co(2:end,end),10,10);
c=c';

  
  
clear estHv;
clear VIMv
clear Hv;
clear estAv;
clear estHv2;
clear estcv;
estA=mean(results.A(:,:,500:end),3);

counter=1;
[M,N]=size(estH);
for ii=1:M
    for jj=1:N
        if(ii~=jj)
            estHv(counter)=estH(ii,jj);
            estHv2(counter)=estH2(ii,jj);
            VIMv(counter)=VIM2(ii,jj);
            Hv(counter)=H(ii,jj);
            estAv(counter)=estA(ii,jj);
            estcv(counter)=c(ii,jj);
            if(estA(ii,jj)>1.2)
                estAv(counter)=0;
            end;
            counter=counter+1;
        end;
    end;
end;

indexi=1;
indexj=2;
clear a1;
for ii=1:size(results.A,3)
    a1(ii)=results.A(indexi,indexj,ii);
end;




[prec, tpr, fpr, thresh,preci,tpri]=prec_rec(estHv,Hv,'spike','plotPR',1,'plotBaseline',1);

     %    au=trapz([0; fpr2], [0; tpr2]); 
             auroc=trapz([0; fpr], [0; tpr]);
            aupr=trapz([0; tpri],[1 ; preci]);
            
           
%title('spike')

%[prec2, tpr2, fpr2, thresh2,preci2,tpri2]=prec_rec(estHv2,Hv,'spikeandseq','style','+-','plotPR',1,'plotBaseline',1,'holdFigure',1);
%aupr2=trapz([0; tpri2],[1 ; preci2]);
%auroc2=trapz([0; fpr2], [0; tpr2]);
[prec3, tpr3, fpr3, thresh3,preci3,tpri3]=prec_rec(VIMv,Hv,'Genie3','plotPR',1,'plotBaseline',1,'holdFigure',1)
aupr3=trapz([0; tpr3],[1 ; prec3]);
auroc3=trapz([0; fpr3], [0; tpr3]);
%title('Genie3')
%title('Genie3')
[prec4, tpr4, fpr4, thresh4,preci4,tpri4]=prec_rec(estcv,Hv,'Genie3','plotPR',1,'plotBaseline',1,'holdFigure',1)
aupr4=trapz([0; tpr4],[1 ; prec4]);
auroc4=trapz([0; fpr4], [0; tpr4]);

prinfer=dlmread('/disk/scratch/Dan/Dropbox/NetworkInferencePaper/InferelatorDream/curves.tsv','\t');
prec5=prinfer(:,1);
tpr5=prinfer(:,2);

auroc5=trapz([0; tpr5],[1 ; prec5]);
 
gam4=plot([0; tpr5],[1 ; prec5]); % add pseudo point to complete curve
            set(gam4,'LineWidth',3);

legend1=['DSS',char(10),' AUPR=',num2str(aupr),' AUC=',num2str(auroc),char(10),char(10),char(10),char(10),char(10),char(10),char(10),char(10),char(10),char(10),char(10),char(10)];
legend2=['sns and sequence',char(10),' AUPR=',num2str(aupr2),' AUC=',num2str(auroc2),char(10),char(10),char(10),char(10),char(10),char(10),char(10),char(10),char(10),char(10),char(10),char(10)];
legend3=['Genie3',char(10),' AUPR=',num2str(aupr3),' AUC=',num2str(auroc3),char(10),char(10),char(10),char(10),char(10),char(10),char(10),char(10),char(10),char(10),char(10),char(10)];
legend4=['LASSO',char(10),' AUPR=',num2str(aupr4),' AUC=',num2str(auroc4)];
legend5=['Inferelator',char(10),'AUPR=',num2str(auroc5)];

      legend('Random',legend1,legend3,legend4,legend5);
       lh=findall(gcf,'tag','legend');
     set(lh,'location','northeast');
   set(lh,'FontSize',130);
  
     

  betameans=zeros(size(results2.beta,1),1);
  betastd=zeros(size(results2.beta,1),1);
  for ii=1:size(results2.beta,1)
          temp=results2.beta(ii,:)
          temp2=temp(temp>0);
          betameans(ii)=mean(temp2);
          betastd(ii)=std(temp2);
  end;
      figure;
      errorbar(betameans,betastd,'ro');

save_results(results1,xi,xid,H,savepath,headers,inputs,constrain,zeromean);

%%
[xi,xid,results1]=sample(M,N,data1,[],@FFTSpectrum);
[xi,xid,results2]=sample(M,N,data2,[],@FFTSpectrum);
[xi,xid,results3]=sample(M,N,data3,[],@FFTSpectrum);
[xi,xid,results4]=sample(M,N,data4,[],@FFTSpectrum);
[xi,xid,results5]=sample(M,N,data5,[],@FFTSpectrum);

resultsfftH=cat(3,results1.H,results2.H,results3.H,results4.H,results5.H);
resultsfftA=cat(3,results1.A,results2.A,results3.A,results4.A,results5.A);
resultsffttau=cat(3,results1.tau,results2.tau,results3.tau,results4.tau,results5.tau);
resultsfftw=cat(1,results1.w,results2.w,results3.w,results4.w,results5.w);
resultsfftprecision=cat(1,results1.precision,results2.precision,results3.precision,results4.precision,results5.precision);
constrain=1;
zeromean=1;
results=struct('H',resultsfftH,'A',resultsfftA,'w',resultsfftw,'tau',resultsffttau,'precision',resultsfftprecision);
save_results(results,xi,xid,H,savepath,headers,inputs,constrain,zeromean);



[xi,xid,results1d]=sample(M,N,data1,[],@CSpectrum);
[xi,xid,results2d]=sample(M,N,data2,[],@CSpectrum);
[xi,xid,results3d]=sample(M,N,data3,[],@CSpectrum);
[xi,xid,results4d]=sample(M,N,data4,[],@CSpectrum);
[xi,xid,results5d]=sample(M,N,data5,[],@CSpectrum);

resultsdctH=cat(3,results1d.H,results2d.H,results3d.H,results4d.H,results5d.H);
resultsdctA=cat(3,results1d.A,results2d.A,results3d.A,results4d.A,results5d.A);
resultsdcttau=cat(3,results1d.tau,results2d.tau,results3d.tau,results4d.tau,results5d.tau);
resultsdctw=cat(1,results1d.w,results2d.w,results3d.w,results4d.w,results5d.w);
resultsdctprecision=cat(1,results1d.precision,results2d.precision,results3d.precision,results4d.precision,results5d.precision);
constrain=1;
zeromean=1;
results=struct('H',resultsdctH,'A',resultsdctA,'w',resultsdctw,'tau',resultsdcttau,'precision',resultsdctprecision);
save_results(results,xi,xid,H,savepath,headers,inputs,constrain,zeromean);

[xi,xid,results1c]=sample(M,N,data1,[],@chebSpectrum);
[xi,xid,results2c]=sample(M,N,data2,[],@chebSpectrum);
[xi,xid,results3c]=sample(M,N,data3,[],@chebSpectrum);
[xi,xid,results4c]=sample(M,N,data4,[],@chebSpectrum);
[xi,xid,results5c]=sample(M,N,data5,[],@chebSpectrum);

resultschH=cat(3,results1c.H,results2c.H,results3d.H,results4c.H,results5c.H);
resultschA=cat(3,results1c.A,results2c.A,results3d.A,results4c.A,results5c.A);
resultschtau=cat(3,results1c.tau,results2c.tau,results3d.tau,results4c.tau,results5c.tau);
resultschw=cat(1,results1c.w,results2d.w,results3c.w,results4c.w,results5c.w);
resultschprecision=cat(1,results1c.precision,results2c.precision,results3c.precision,results4c.precision,results5c.precision);
constrain=1;
zeromean=1;
results=struct('H',resultschH,'A',resultschA,'w',resultschw,'tau',resultschtau,'precision',resultschprecision);
save_results(results,xi,xid,H,savepath,headers,inputs,constrain,zeromean);


